softwaretype<-NA

#parameters of the process to invoke
false<-F
true<-T
softwaretype<-'Windows-compiled'
softwareName<-'EwECmd.exe'
PInput1<-"run_config.xml"
cat('Input Parameter:PInput1',PInput1,'\n')
PInput2<-"Georgia_Strait.eiixml"
cat('Input Parameter:PInput2',PInput2,'\n')
overallInput<-'PInput1	PInput2'
overallInputValues<-paste(PInput1,PInput2,sep='	')
overallInputTypes<-'File	File'



external_process_to_invoke<-'EwECmd.exe' #can be a python, fortran, linux-compiled, octave, java process
#prepare the command to invoke
command = paste(external_process_to_invoke,paste('"',PInput1,'"',sep=''),paste('"',PInput2,'"',sep=''),sep=" ")
cat('Command:',command,'\n')



cat("Adding rights to the files\n")
logs<-system("chmod 755 *", intern = TRUE)
cat("computation started\n")
cat("software type:",softwaretype,"\n")
#run the process
if (is.na(softwaretype)){
}else if (softwaretype=='Windows-compiled'){
	cat("Windows computation\n")
	command<-paste('mono ./',command,sep='')
}else if (softwaretype=='Linux-compiled'){
	cat("Linux computation\n")
	command<-paste('./',command,sep='')
}else if (softwaretype=='Pre-Installed'){
	cat("Pre-installed computation\n")
	command<-paste('./',command,sep='')
}else if (softwaretype=='R-blackbox'){
	cat("R computation\n")
	command<-paste('Rscript --vanilla ',command,sep='')
}else if (softwaretype=='Python'){
	cat("Python computation\n")
	command<-paste('python -m ',command,sep='')
}else if (softwaretype=='Java'){
	cat("Java computation\n")
	command<-paste('java -cp ./',command,sep='')
}else if (softwaretype=='Octave'){
	cat("Octave computation\n")
	command<-paste('octave ./',command,sep='')
}else if (softwaretype=='Knime-Workflow'){
  cat("Knime computation\n")
  workflow<-"workflow.zip"
  if (file.exists(paste(softwareName,'.zip',sep='')))
    file.rename(paste(softwareName,'.zip',sep=''),softwareName)
  #EXAMPLE: knime -reset -consoleLog -nosplash -application org.knime.product.KNIME_BATCH_APPLICATION 
  #-workflowFile=SimpleSample.knwf -destFile=out.zip -workflow.variable=test,"besttest",String
  oI<-strsplit(overallInput,"\t")
  oIv<-strsplit(overallInputValues,"\t")
  oIt<-strsplit(overallInputTypes,"\t")

  knimevariables<-""
  for (i in 1:length(oI[[1]])){
		oinp<-oI[[1]][i]
		oinpv<-oIv[[1]][i]
		oinpt<-oIt[[1]][i]
		if (tolower(oinpt) == 'integer')
			oinpt<-"int"
		else if (tolower(oinpt) == 'double')
			oinpt<-"double"
		else {
			oinpv<-gsub(' ', '_', oinpv)
			oinpv<-gsub(',', ';', oinpv)
			oinpt<-"String"
		}
		
		knimevar = paste(oinp,",",'"',oinpv,'"',",",oinpt,sep="")
		
		knimevariables<-paste(knimevariables,' -workflow.variable=',knimevar,sep="")
		
	}
  command<-paste('/usr/local/bin/knime-full -reset -consoleLog -nosplash -application org.knime.product.KNIME_BATCH_APPLICATION -workflowFile=',softwareName,' -destFile=',workflow,knimevariables, sep='')
}
	
cat(command,"\n")
logs<-system(command, intern = TRUE)
cat("computation finished\n")
cat("Logs of the computation\n")
print(logs)
cat("\n")


#prepare the final output file
outputfolder <- getwd() #current working folder (a temporary folder is created at each run and set as working directory)
POutput1<-"Georgia_Strait_log.xml"
#fixed code to add some randomness to the output file name and save concurrent requests
POutput1<-paste(POutput1,'_',Sys.time(),sep='')
POutput1<-gsub(' ', '_', POutput1)
POutput1<-gsub(':', '_', POutput1)
file.rename('Georgia_Strait_log.xml',POutput1)
cat('Output Parameter:POutput1',POutput1,'\n')



#check if the output exists before exiting
fexists = file.exists(paste(POutput1,sep=''))
cat("file POutput1 exists?",fexists,"\n")
if (!fexists){
	cat(fexists,"Error, the output POutput1(Georgia_Strait_log.xml) does not exist!\n")
	stoptheprocess
}


