package org.gcube.dataanalysis.executor.rscripts;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import org.gcube.dataanalysis.ecoengine.datatypes.PrimitiveType;
import org.gcube.dataanalysis.ecoengine.datatypes.StatisticalType;
import org.gcube.dataanalysis.ecoengine.datatypes.enumtypes.PrimitiveTypes;
import org.gcube.dataanalysis.executor.rscripts.generic.GenericRScript;
import org.gcube.dataanalysis.ecoengine.utils.DynamicEnum;
import java.lang.reflect.Field;

public class WindowsBlackBox extends GenericRScript {

	@Override
	public String getDescription() {
		return "WindowsBlackBox";
	}

	protected void initVariables(){
		mainScriptName="WindowsBlackBox/Main.R";
		packageURL="http://data.d4science.org/WXhPU3VndnNYZG43NkFFb2dIU0hQMlIvVDJSVVQzNk5HbWJQNStIS0N6Yz0";
		environmentalvariables = new ArrayList<String>();
		inputvariables.add("PInput1");
		inputvariables.add("PInput2");
		outputvariables.add("POutput1");
	}

	@Override
	protected void setInputParameters() {
		inputs.add(new PrimitiveType(File.class.getName(), null,PrimitiveTypes.FILE, "PInput1", "Parameter Input 1", "run_config.xml"));
		inputs.add(new PrimitiveType(File.class.getName(), null,PrimitiveTypes.FILE, "PInput2", "Parameter Input 2", "Georgia_Strait.eiixml"));
	}

	@Override
	public StatisticalType getOutput() {
		output.put("POutput1",new PrimitiveType(File.class.getName(), new File(outputValues.get("POutput1")), PrimitiveTypes.FILE, "POutput1", "POutput1"));
		PrimitiveType o = new PrimitiveType(LinkedHashMap.class.getName(), output, PrimitiveTypes.MAP, "Output", "");
		return o;
	}
}
